<?php

/**
 * no_total_nomina actions.
 *
 * @package    nomina
 * @subpackage no_total_nomina
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class no_total_nominaActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by id_periodo, num_doc ';
        }



        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //clase_planta
            if (isset($request['id_clase_planta'])) {
                $whereClasePlanta = " AND tab0.id_clase_planta = " . $request['id_clase_planta'];
            } else {
                $whereClasePlanta = ' ';
            }
            //Filtros nuevos - 20190326
            //id_cen_op
            if (isset($request['id_cen_op'])) {
                $whereCenOp = " AND tab0.id_cen_op = " . $request['id_cen_op'];
            } else {
                $whereCenOp = ' ';
            }
            //id_area
            if (isset($request['id_area'])) {
                $whereArea = " AND tab0.id_ea = " . $request['id_area'];
            } else {
                $whereArea = ' ';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             * Filtro de conceptos para pago . and concep.pago_func = 1 - 20140428
             */
            /**
             * En el desarrollo del proceso de la liquidación de la nómina de Julio de Colciencias, 
             * como es de tu conocimiento tenemos pendiente entregar el informe de prenómina con 
             * los porcentajes de la prima de méritos, número de horas extras y porcentaje de prima tecnica. - 20140718
             */
            $sql = <<<EOD
select count(*) as count from (

select 

nvl(min(tab.valor_sal),max(tab.asignacion_basica)) as asignacion_basica,
max(tab.dias_basica) as dias_basica,

tab.id_tipo_doc,
tab.num_doc,
tab.id_periodo,
tab.nombre_apellido,
tab.nombre_completo,
max(tab.fecha_ingreso) as fecha_ingreso,
max(tab.fecha_termina) as fecha_termina,
max(tab.fecha_retiro) as fecha_retiro,
sum(tab.val_deven) as val_deven,
sum(tab.val_dedley) as val_dedley,
sum(tab.val_dednoley) as val_dednoley,
sum(tab.val_deven) - sum(tab.val_dedley) - sum(tab.val_dednoley) as total_neto

from (

    select 
    sal.valor as valor_sal,
    tab0.* 
        
    from (
      
        select 
        
        estfun.id_ea,
        estfun.id_cen_op,
        
        nomb.fecha_ingreso,
        nomb.fecha_termina,
        nomb.fecha_retiro,
        nomb.id_clase_planta,
        
        tab0.id_tipo_doc,
        tab0.num_doc,
        tab0.id_concep_nomina,
        tab0.id_periodo,
        tab0.valor_liquidado,
        tab0.nombre_apellido,
        tab0.nombre_completo,
        tab0.codigo,
        tab0.descripcion,
        tab0.estado,
        tab0.operador,
        tab0.id_tipo_concepto,
        tab0.codigo_tipcon,
        tab0.descripcion_tipcon,
        tab0.id_tipo_periodo,
        tab0.codigo_tipper,
        tab0.descripcion_tipper,
        
        case when tab0.id_tipo_concepto = 1 then tab0.valor_liquidado else 0 end as val_deven,
        case when tab0.id_tipo_concepto = 2 then tab0.valor_liquidado else 0 end as val_dedley,
        case when tab0.id_tipo_concepto = 3 then tab0.valor_liquidado else 0 end as val_dednoley,
        
        case when tab0.id_concep_nomina = (select no_param_concep.id_concep_basica from no_param_concep where no_param_concep.id_param_concep = 1) then tab0.valor_liquidado else 0 end as asignacion_basica,        
        case when tab0.id_concep_nomina = (select no_param_concep.id_concep_basica from no_param_concep where no_param_concep.id_param_concep = 1) then tab0.num_dias else 0 end as dias_basica
                    
        from no_liquida_nomina_v tab0
        
        left join no_concep_nomina connom
        on tab0.id_concep_nomina = connom.id_concep_nomina
        
        left join no_nombramiento_v nomb
        on nomb.id_tipo_doc = tab0.id_tipo_doc
        and nomb.num_doc = tab0.num_doc
        
        left join no_estado_func_v estfun
        on estfun.id_tipo_doc = tab0.id_tipo_doc
        and estfun.num_doc = tab0.num_doc
        and estfun.periodo = tab0.id_periodo
        
        where
        connom.pago_func = 1
        and tab0.id_periodo = $periodo_filtro              
        $whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
     
     )tab0

    /* Se cambia salario por registro de concepto_periodo, para tener el que se pago en el periodo - 20150609, Se toma el periodo mensaul-20170622*/
    left join (
      SELECT
       aut.*,
       ROW_NUMBER() OVER (
        partition by aut.num_doc
        ORDER BY aut.fecha_hasta desc, aut.id_concepto_periodo desc
       ) AS rn
      from no_concepto_periodo aut
      where
      aut.periodo in (
          select id_periodo from no_periodo_v where id_tipo_periodo = 1 and anho_mes = (select anho_mes from no_periodo_v where id_periodo = $periodo_filtro)
      )
      and aut.id_concep_nomina = (select no_param_concep.id_concep_basica from no_param_concep where no_param_concep.id_param_concep = 1)
    )sal
    on sal.id_tipo_doc = tab0.id_tipo_doc
    and sal.num_doc = tab0.num_doc
    and sal.rn = 1
                    
    where
    1 = 1
    $whereClasePlanta
    $whereCenOp
    $whereArea     

)tab

group by 
tab.id_tipo_doc,
tab.num_doc,
tab.id_periodo,
tab.nombre_apellido,
tab.nombre_completo

   
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
    
select 

nvl(min(tab.valor_sal),max(tab.asignacion_basica)) as asignacion_basica,
max(tab.dias_basica) as dias_basica,

tab.id_tipo_doc,
tab.num_doc,
tab.id_periodo,
tab.nombre_apellido,
tab.nombre_completo,
max(tab.fecha_ingreso) as fecha_ingreso,
max(tab.fecha_termina) as fecha_termina,
max(tab.fecha_retiro) as fecha_retiro,
sum(tab.val_deven) as val_deven,
sum(tab.val_dedley) as val_dedley,
sum(tab.val_dednoley) as val_dednoley,
sum(tab.val_deven) - sum(tab.val_dedley) - sum(tab.val_dednoley) as total_neto

from (

    select 
    sal.valor as valor_sal,
    tab0.* 
        
    from (
      
        select 
        
        estfun.id_ea,
        estfun.id_cen_op,
        
        nomb.fecha_ingreso,
        nomb.fecha_termina,
        nomb.fecha_retiro,
        nomb.id_clase_planta,
        
        tab0.id_tipo_doc,
        tab0.num_doc,
        tab0.id_concep_nomina,
        tab0.id_periodo,
        tab0.valor_liquidado,
        tab0.nombre_apellido,
        tab0.nombre_completo,
        tab0.codigo,
        tab0.descripcion,
        tab0.estado,
        tab0.operador,
        tab0.id_tipo_concepto,
        tab0.codigo_tipcon,
        tab0.descripcion_tipcon,
        tab0.id_tipo_periodo,
        tab0.codigo_tipper,
        tab0.descripcion_tipper,
        
        case when tab0.id_tipo_concepto = 1 then tab0.valor_liquidado else 0 end as val_deven,
        case when tab0.id_tipo_concepto = 2 then tab0.valor_liquidado else 0 end as val_dedley,
        case when tab0.id_tipo_concepto = 3 then tab0.valor_liquidado else 0 end as val_dednoley,
        
        case when tab0.id_concep_nomina = (select no_param_concep.id_concep_basica from no_param_concep where no_param_concep.id_param_concep = 1) then tab0.valor_liquidado else 0 end as asignacion_basica,        
        case when tab0.id_concep_nomina = (select no_param_concep.id_concep_basica from no_param_concep where no_param_concep.id_param_concep = 1) then tab0.num_dias else 0 end as dias_basica
                    
        from no_liquida_nomina_v tab0
        
        left join no_concep_nomina connom
        on tab0.id_concep_nomina = connom.id_concep_nomina
        
        left join no_nombramiento_v nomb
        on nomb.id_tipo_doc = tab0.id_tipo_doc
        and nomb.num_doc = tab0.num_doc
        
        left join no_estado_func_v estfun
        on estfun.id_tipo_doc = tab0.id_tipo_doc
        and estfun.num_doc = tab0.num_doc
        and estfun.periodo = tab0.id_periodo
        
        where
        connom.pago_func = 1
        and tab0.id_periodo = $periodo_filtro              
        $whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
     
     )tab0

    /* Se cambia salario por registro de concepto_periodo, para tener el que se pago en el periodo - 20150609, Se toma el periodo mensaul-20170622*/
    left join (
      SELECT
       aut.*,
       ROW_NUMBER() OVER (
        partition by aut.num_doc
        ORDER BY aut.fecha_hasta desc, aut.id_concepto_periodo desc
       ) AS rn
      from no_concepto_periodo aut
      where
      aut.periodo in (
          select id_periodo from no_periodo_v where id_tipo_periodo = 1 and anho_mes = (select anho_mes from no_periodo_v where id_periodo = $periodo_filtro)
      )
      and aut.id_concep_nomina = (select no_param_concep.id_concep_basica from no_param_concep where no_param_concep.id_param_concep = 1)
    )sal
    on sal.id_tipo_doc = tab0.id_tipo_doc
    and sal.num_doc = tab0.num_doc
    and sal.rn = 1
                    
    where
    1 = 1
    $whereClasePlanta
    $whereCenOp
    $whereArea     

)tab

group by 
tab.id_tipo_doc,
tab.num_doc,
tab.id_periodo,
tab.nombre_apellido,
tab.nombre_completo
                    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_prenomina_detalle] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Metodo para sumar 
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by id_periodo, num_doc ';
        }

        //manejo de errores
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //clase_planta
            if (isset($request['id_clase_planta'])) {
                $whereClasePlanta = " AND tab0.id_clase_planta = " . $request['id_clase_planta'];
            } else {
                $whereClasePlanta = ' ';
            }
            //Filtros nuevos - 20190326
            //id_cen_op
            if (isset($request['id_cen_op'])) {
                $whereCenOp = " AND tab0.id_cen_op = " . $request['id_cen_op'];
            } else {
                $whereCenOp = ' ';
            }
            //id_area
            if (isset($request['id_area'])) {
                $whereArea = " AND tab0.id_ea = " . $request['id_area'];
            } else {
                $whereArea = ' ';
            }

            //obtener el listado de recaudos
            // Filtro de conceptos para pago . and concep.pago_func = 1 - 20140428
            $sql = <<<EOD
SELECT

   'TOTALES' as num_doc,
   'Cantidad de Funcionarios ' || count(num_doc) as nombre_apellido,

   SUM(val_deven)  as val_deven,
   SUM(val_dedley)  as val_dedley,
   SUM(val_dednoley)  as val_dednoley,
   SUM(total_neto)  as total_neto

FROM (   

select 

tab.id_tipo_doc,
tab.num_doc,
tab.id_periodo,
tab.nombre_apellido,
tab.nombre_completo,
max(tab.fecha_ingreso) as fecha_ingreso,
max(tab.fecha_termina) as fecha_termina,
max(tab.fecha_retiro) as fecha_retiro,
sum(tab.val_deven) as val_deven,
sum(tab.val_dedley) as val_dedley,
sum(tab.val_dednoley) as val_dednoley,
sum(tab.val_deven) - sum(tab.val_dedley) - sum(tab.val_dednoley) as total_neto

from (

    select tab0.* from (
      
        select 
        
        estfun.id_ea,
        estfun.id_cen_op,
        
        nomb.fecha_ingreso,
        nomb.fecha_termina,
        nomb.fecha_retiro,
        nomb.id_clase_planta,
        
        tab0.id_tipo_doc,
        tab0.num_doc,
        tab0.id_concep_nomina,
        tab0.id_periodo,
        tab0.valor_liquidado,
        tab0.nombre_apellido,
        tab0.nombre_completo,
        tab0.codigo,
        tab0.descripcion,
        tab0.estado,
        tab0.operador,
        tab0.id_tipo_concepto,
        tab0.codigo_tipcon,
        tab0.descripcion_tipcon,
        tab0.id_tipo_periodo,
        tab0.codigo_tipper,
        tab0.descripcion_tipper,
        
        case when tab0.id_tipo_concepto = 1 then tab0.valor_liquidado else 0 end as val_deven,
        case when tab0.id_tipo_concepto = 2 then tab0.valor_liquidado else 0 end as val_dedley,
        case when tab0.id_tipo_concepto = 3 then tab0.valor_liquidado else 0 end as val_dednoley
        from no_liquida_nomina_v tab0
        
        left join no_concep_nomina connom
        on tab0.id_concep_nomina = connom.id_concep_nomina
        
        left join no_nombramiento_v nomb
        on nomb.id_tipo_doc = tab0.id_tipo_doc
        and nomb.num_doc = tab0.num_doc
        
        left join no_estado_func_v estfun
        on estfun.id_tipo_doc = tab0.id_tipo_doc
        and estfun.num_doc = tab0.num_doc
        and estfun.periodo = tab0.id_periodo
        
        where
        connom.pago_func = 1
        and tab0.id_periodo = $periodo_filtro              
        $whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
     
    )tab0
    where
    1 = 1
    $whereClasePlanta
    $whereCenOp
    $whereArea     

)tab

group by 
tab.id_tipo_doc,
tab.num_doc,
tab.id_periodo,
tab.nombre_apellido,
tab.nombre_completo

$sortBy

)

EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
